'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.download = exports.upload = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var upload = exports.upload = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(local, remote) {
    var tag, release, names, name;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            tag = remote.tag;
            _context.next = 3;
            return (0, _github.getRelease)(tag);

          case 3:
            release = _context.sent;

            if (release) {
              _context.next = 8;
              break;
            }

            _context.next = 7;
            return (0, _github.getReleaseDraft)(tag);

          case 7:
            release = _context.sent;

          case 8:
            if (release) {
              _context.next = 12;
              break;
            }

            _context.next = 11;
            return (0, _github.createRelease)(tag);

          case 11:
            release = _context.sent;

          case 12:
            names = release.assets.map(function (_ref2) {
              var name = _ref2.name;

              (0, _assert2.default)(name);
              return name;
            });
            name = uniqueName(remote.name, names);
            _context.next = 16;
            return (0, _github.uploadAsset)(local, release, name);

          case 16:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function upload(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var download = exports.download = function () {
  var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(remote, local) {
    var tag, tempFile, short, ok, release, assets, asset;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            tag = remote.tag;
            tempFile = local + '.downloading';
            _context2.next = 4;
            return (0, _fsPromise.mkdirp)(_path2.default.dirname(tempFile));

          case 4:
            short = _path2.default.basename(local);
            _context2.next = 7;
            return (0, _github.tryDirectly)(tag, remote.name, tempFile, short);

          case 7:
            ok = _context2.sent;

            if (ok) {
              _context2.next = 25;
              break;
            }

            _context2.next = 11;
            return (0, _github.getRelease)(tag);

          case 11:
            release = _context2.sent;

            if (release) {
              _context2.next = 16;
              break;
            }

            _context2.next = 15;
            return (0, _github.getReleaseDraft)(tag);

          case 15:
            release = _context2.sent;

          case 16:
            if (release) {
              _context2.next = 18;
              break;
            }

            return _context2.abrupt('return', false);

          case 18:
            assets = release.assets.filter(function (_ref4) {
              var name = _ref4.name;

              (0, _assert2.default)(name);
              return name === remote.name;
            });

            if (assets.length) {
              _context2.next = 21;
              break;
            }

            return _context2.abrupt('return', false);

          case 21:
            (0, _assert2.default)(assets.length === 1);
            asset = assets[0];
            _context2.next = 25;
            return (0, _github.downloadUrl)(asset.url, tempFile, short);

          case 25:
            _context2.next = 27;
            return (0, _fsPromise.remove)(local);

          case 27:
            _context2.next = 29;
            return (0, _copyFile.moveFile)(tempFile, local);

          case 29:
            _context2.next = 31;
            return (0, _fsPromise.remove)(tempFile);

          case 31:
            return _context2.abrupt('return', true);

          case 32:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function download(_x3, _x4) {
    return _ref3.apply(this, arguments);
  };
}();

var _github = require('./github.js');

var _fsPromise = require('fs-promise');

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _copyFile = require('./copy-file.js');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function uniqueName(name, names) {
  if (names.indexOf(name) < 0) return name;
  var newName = void 0;
  var counter = 0;
  while (true) {
    newName = name + '-' + counter;
    if (names.indexOf(newName) < 0) return newName;
    counter += 1;
  }
}